ALTER PROCEDURE [dbo].[P_DRIVERS](@UniKey int=NULL OUTPUT,@R int=1 OUTPUT,
@COMMENT varchar(512)=NULL OUTPUT,
@FA varchar(32)=NULL,@TaxiNum int=null,
@IM varchar(32)=NULL,@OT varchar(32)=NULL,
@p_ser varchar(16)=NULL, @p_num varchar(16)=NULL, @p_organ varchar(64)=NULL, @p_date datetime=NULL,
@p_place varchar(128)=NULL, @p_birth varchar(128)=NULL, @i_place varchar(128)=NULL,
@v_ser varchar(16)=NULL, @v_num varchar(16)=NULL, @v_date datetime=NULL,@v_date_end datetime=null, @INN varchar(12)=NULL,
@v_state int=NULL,@Photo image=null,
 @JLogin varchar(20)=NULL, @JPassword varchar(20)=NULL, @JEnterPrice bit=0,
@ControlBalance int=0, @ControlBalanceSum money=0, @JLockGeoRegion int=null,
@isJLockGeoRegion bit=null, @Phone varchar(20)=null,
@isSetTaksa bit=0, @UserUpdate int=null,
@ControlBalanceClearing bit=1,
@ATPKey int=NULL,
@BirthDate datetime=null,
@license_num varchar(32)=null,
@SelectOrder varchar(1024)=null)  AS
begin
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <17/02/2010>
-- Update date: <24/06/2015>
-- Description:	<>
-- =============================================
SET DATEFORMAT dmy;
DECLARE @Q varchar(4000)
DECLARE @DDateA datetime,@DDateB datetime,@DRet integer,@Driver int,
@taxi_taksa money=NULL,@TaksaType int=NULL, @taxi_calc money=NULL, @taxi_percent float=NULL,
@isShowAllGeoRegion bit=1, @isShowAllZakazType bit=1,@UserGroupKey int=null;
DECLARE @MessageText varchar(256);

	if @R=1 /**/
		begin
		if (@UserUpdate IS NOT NULL)
			begin
			SELECT @UserGroupKey=UserGroupKey, @isShowAllZakazType=isShowAllZakazType, @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WHERE UniKey=@UserUpdate;
			end;
		SET @Q='SELECT DDD.[UNIKEY],[FA],[IM],[OT],DDD.[INN],[p_ser],[p_num],[p_organ],[p_date],[p_place],
		[p_birth],[i_place],[COMMENT],[v_ser],[v_num],[v_date],[v_date_end],[v_state],[JLogin],[JPassword]
,[JEnterPrice],[ControlBalance],[ControlBalanceSum],[isJLockGeoRegion],[JLockGeoRegion],DDD.BirthDate,DDD.license_num,
dbo.GetFIO(DDD.UNIKEY) FIO,dbo.ZalogSUM(DDD.UNIKEY) ZALOGSUMMA,DDD.DateUpdate, DDD.DateCreate,
			dbo.GetDriverRatesStr(DDD.UNIKEY,GETDATE()) DriverRatesStr,
			[dbo].[GetDriverRatingFinal](DDD.UniKey) as RatingFinal,
			tdr.TAXI as TaxiNum, GOV_NUMBER,CarType,
			DP.ActiveBalance, DP.ClientType, DP.isOnline,Cars.DatePurchase, DP.LastVersion,DDD.ATPKey,LP.OrgName as ATPOrgName
			 FROM DRIVERS DDD WITH (nolock)
			 LEFT JOIN DriversPlace DP ON DDD.UniKey=DP.Driver
			LEFT JOIN TAXI_DR TDR ON TDR.DRIVER=DDD.UniKey AND (DATEIN<=GETDATE() AND (DATEOUT IS NULL OR DATEOUT>=GETDATE()))
			LEFT JOIN Cars ON Cars.UniKey=TDR.Car
			LEFT JOIN LegalPerson LP ON LP.UniKey=DDD.ATPKey';
		--  ,    
		if(@UserGroupKey IS NOT NULL) SET @Q=@Q+' INNER JOIN UsersGroupsDrivers UGD ON UGD.UserGroupKey='+CAST(@UserGroupKey as varchar(16))+' AND UGD.DriverKey=DDD.UniKey';
			
		SET @Q=@Q+' WHERE 1=1';
		if (@v_state IS NOT NULL) SET @Q=@Q+' AND v_state=0'; --+CAST(@v_state as varchar(16));
		if (@Phone IS NOT NULL) SET @Q=@Q+' AND DDD.UniKey IN (SELECT DriverKey FROM PhoneDrivers PD WITH (nolock) LEFT JOIN BlackListTEL BLT ON PD.PhoneKey=BLT.UniKey WHERE NUMTEL LIKE '''+@Phone +''')';
		if (@UserUpdate IS NOT NULL)
			begin
			--    
			if @isShowAllGeoRegion=0 SET @Q =@Q + ' AND DDD.isJLockGeoRegion=1 AND DDD.JLockGeoRegion IN (SELECT GeoRegion FROM User_GeoRegion_Link WITH (nolock) WHERE UserKey='+CAST(@UserUpdate as varchar(12))+')';
			--     
			if @isShowAllZakazType=0 SET @Q =@Q + ' AND CarType IN (SELECT ZakazType FROM User_ZakazType_Link WITH (nolock) WHERE UserKey='+CAST(@UserUpdate as varchar(12))+')';
			end;
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY FA,IM,OT';
		Exec (@Q);
		return;
		end;
	if @R=2 /**/
		begin
		--    
		if NOT EXISTS(SELECT UniKey FROM Drivers WITH (nolock) WHERE UniKey=@Unikey) return;
		
		UPDATE DRIVERS SET FA=@FA, IM=@IM, OT=@OT, p_ser=@p_ser, p_num=@p_num, p_organ=@p_organ,
			p_date=@p_date, p_place=@p_place, p_birth=@p_birth, i_place=@i_place,
			v_ser=@v_ser, v_num=@v_num, v_date=@v_date, INN=@INN,v_date_end=@v_date_end,Photo=@Photo,
			COMMENT=@COMMENT,v_state=@v_state,JLogin=@JLogin, JPassword=@JPassword,
			JEnterPrice=@JEnterPrice,ControlBalance=@ControlBalance,ControlBalanceSum=@ControlBalanceSum,
			JLockGeoRegion=@JLockGeoRegion, isJLockGeoRegion=@isJLockGeoRegion, DateUpdate=GETDATE(),
			ControlBalanceClearing=@ControlBalanceClearing,ATPKey=@ATPKey,BirthDate=@BirthDate,
			license_num=@license_num
			 WHERE UniKey=@Unikey;
		
		if (@v_state=0)
			begin
			if (NOT EXISTS(SELECT * FROM DriversPlace WITH (nolock) WHERE Driver=@Unikey))
				begin
				INSERT INTO DriversPlace (Driver,GeoRegion,Zone,isManual,isFree,  isOnline,LastActivity,[Queue]) 
					VALUES (@Unikey,@JLockGeoRegion,NULL,0,1,0,GETDATE(),
					isnull((SELECT MAX([QUEUE]) FROM DriversPlace),1)+1);
				end;
			end
			else 
			begin
				DELETE FROM DriversPlace WHERE Driver=@Unikey;
			end;
		--    
		if (@UserUpdate IS NOT NULL)
			begin
			SELECT @UserGroupKey=UserGroupKey FROM USERS WITH (nolock) WHERE UniKey=@UserUpdate;
			if(@UserGroupKey IS NOT NULL) 
				begin
				IF NOT EXISTS(SELECT 1 FROM UsersGroupsDrivers UGD WITH (nolock) WHERE UGD.DriverKey=@UniKey AND UGD.UserGroupKey=@UserGroupKey)
					begin
					DELETE FROM UsersGroupsDrivers WHERE DriverKey=@UniKey;
					INSERT INTO UsersGroupsDrivers (DriverKey,UserGroupKey) VALUES (@UniKey,@UserGroupKey);
					end;
				end;
			end;
		
		return;
		end;
	if @R=3 /* */
		begin
		INSERT INTO DRIVERS (FA,v_state) VALUES ('temporary',1);
		SET @Driver=SCOPE_IDENTITY();
		--INSERT INTO DriversPlace (Driver,Zone,isManual,isFree,  isOnline) VALUES (@R,NULL,0,1,0);
		--   
		if (@isSetTaksa=1)
			begin
				DECLARE RateCursor CURSOR FOR
				SELECT UniKey,taxi_taksa,TaksaType, taxi_calc, taxi_percent FROM Rates WITH (nolock) WHERE isEnabled=1 AND TaksaType IS NOT NULL;
				OPEN RateCursor
					FETCH NEXT FROM RateCursor INTO @DRet,@taxi_taksa,@TaksaType, @taxi_calc, @taxi_percent;
					WHILE @@FETCH_STATUS = 0
						BEGIN
							INSERT INTO TAKSA (DRIVER,DATEIN,DATEOUT,taxi_percent,taxi_taksa,TaksaType,
								taxi_calc,Rate) VALUES (@Driver, GETDATE(),NULL,@taxi_percent,@taxi_taksa,@TaksaType,
								@taxi_calc, @DRet);
							FETCH NEXT FROM RateCursor  INTO @DRet,@taxi_taksa,@TaksaType, @taxi_calc, @taxi_percent;
						END 
				CLOSE RateCursor
				DEALLOCATE RateCursor;		
			end;
		SET @R=@Driver;
		UPDATE DRIVERS SET PROMOCODE=@Driver WHERE UNIKEY=@Driver;
		return;
		end;
	if @R=4 /* */
		begin
		BEGIN TRANSACTION; DELETE FROM TAXI_DR WHERE DRIVER=@Unikey; COMMIT TRANSACTION;
		BEGIN TRANSACTION; DELETE FROM Zalog WHERE DRIVER=@Unikey; COMMIT TRANSACTION;
		BEGIN TRANSACTION; DELETE FROM TAKSA WHERE DRIVER=@Unikey; COMMIT TRANSACTION;
		BEGIN TRANSACTION; DELETE FROM UsersGroupsDrivers WHERE DriverKey=@Unikey; COMMIT TRANSACTION;
		BEGIN TRANSACTION; DELETE FROM PiramideDrivers WHERE DRIVERParent=@Unikey OR DriverChild=@Unikey; COMMIT TRANSACTION;
		BEGIN TRANSACTION; DELETE FROM PhoneDrivers WHERE DriverKey=@Unikey; COMMIT TRANSACTION;
		BEGIN TRANSACTION; DELETE FROM DriversPlace WHERE Driver=@Unikey; COMMIT TRANSACTION;
		BEGIN TRANSACTION; DELETE FROM CASHIN WHERE Driver=@Unikey; COMMIT TRANSACTION;
		BEGIN TRANSACTION; UPDATE BASE SET Driver=NULL WHERE Driver=@Unikey; COMMIT TRANSACTION;

		DELETE FROM DRIVERS  WHERE UniKey=@Unikey;
		return;
		end;
	if @R=5 /*   */
		begin
		SET @taxi_taksa=ISNULL(-dbo.GetDriverSUMDolgFast(@Unikey),0);
		SELECT @taxi_calc=ActiveBalance FROM DriversPlace WHERE Driver=@Unikey;
		if isNull(@taxi_calc,0)!=@taxi_taksa UPDATE DriversPlace SET ActiveBalance=@taxi_taksa WHERE Driver=@Unikey;
		SELECT DDD.*,dbo.GetCurrentTaxiNum(DDD.UNIKEY,GETDATE()) as TaxiNum,[dbo].[GetDriverRatingFinal](DDD.UniKey) as RatingFinal,
			dbo.ZalogSUM(DDD.UNIKEY) as ZALOGSUMMA,dbo.CashInSUM(DDD.UNIKEY) as DriverCashIn,
			@taxi_taksa as DriverSUMDolg,DP.Zone,DP.ClientType,DP.GeoRegion,
			CCC.GOV_NUMBER as GOV_NUMBER,
			CCC.UniKey as Car,
			CCC.CarType as CarType,
			DP.LastActivity,lat,lon,DP.isOnline,DP.LastVersion, DCT.ClientTypeName, DP.isFree,
			DP.DateAcceptPhoto, DP.DateRejectPhoto, DPCL.DriverPhotoKey,DP.current_speed
			 FROM DRIVERS DDD WITH (nolock)
			 LEFT JOIN DriversPlace DP ON DP.Driver=DDD.UniKey 
			 LEFT JOIN DriverClientType DCT ON DCT.UniKey=DP.ClientType  AND DCT.Lng =(SELECT TOP 1 LngMain FROM PROPERTIES)
			 LEFT JOIN TAXI_DR TDR ON TDR.DRIVER=DDD.UniKey AND (DATEIN<=GETDATE() AND (DATEOUT IS NULL OR DATEOUT>=GETDATE()))
			 LEFT JOIN Cars CCC ON CCC.UniKey=TDR.Car			 
			 LEFT JOIN DriverPhotoCarLink DPCL ON DPCL.CarKey=TDR.Car
			 WHERE DDD.UniKey=@Unikey;
		return;
		end;

	if @R=6 /*  . */
		begin
		if (@UserUpdate IS NOT NULL)
			begin
			SELECT @UserGroupKey=UserGroupKey, @isShowAllZakazType=isShowAllZakazType, @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WITH (nolock) WHERE UniKey=@UserUpdate;
			end;
		SET @Q='SELECT DDD.UNIKEY,dbo.GetFIO(DDD.UNIKEY) FIO,CCC.GOV_NUMBER,TDR.TAXI as TaxiNum 
		FROM DRIVERS DDD WITH (nolock)
		LEFT JOIN TAXI_DR TDR ON TDR.DRIVER=DDD.UniKey AND (DATEIN<=GETDATE() AND (DATEOUT IS NULL OR DATEOUT>=GETDATE()))
		LEFT JOIN Cars CCC ON CCC.UniKey=TDR.Car';
		--  ,    
		if(@UserGroupKey IS NOT NULL) SET @Q=@Q+' INNER JOIN UsersGroupsDrivers UGD ON UGD.UserGroupKey='+CAST(@UserGroupKey as varchar(16))+' AND UGD.DriverKey=DDD.UniKey';
		
		SET @Q=@Q+' WHERE 1=1';
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY FIO';
		Exec (@Q);
		return;
		end;

	if @R=7 /*         :)+  */
		begin
		
		DECLARE BaseCursor CURSOR FOR
		SELECT UniKey FROM BASE WITH (nolock) WHERE Driver=@UniKey;
		OPEN BaseCursor
			FETCH NEXT FROM BaseCursor INTO @DRet;
			WHILE @@FETCH_STATUS = 0
				BEGIN
					UPDATE BASE SET Debt=[dbo].[GetSUMDolgByZakaz](@DRet) WHERE UNIKEY=@DRet;
					FETCH NEXT FROM BaseCursor  INTO @DRet;
				END 
		CLOSE BaseCursor
		DEALLOCATE BaseCursor;
		
		Exec P_BalanceSheet @R=2,@UniKey=@UniKey,@ret=@DRet OUTPUT;
		Select -dbo.GetDriverSUMDolgFast(ddd.UNIKEY) as DriverSUMDolg,
			dbo.ZalogSUM(@UniKey) DriverSumZalog  FROM Drivers ddd Where UNIKEY=@UniKey;
		return;
		end;
	if @R=8 /*     */
		begin
		--  
		DECLARE @isControlDriverCardNum bit, @isControlDriverPassport bit, @isControlDriverFIO bit;
		SELECT TOP 1 @isControlDriverCardNum=isControlDriverCardNum, @isControlDriverPassport=isControlDriverPassport, @isControlDriverFIO=isControlDriverFIO FROM PROPERTIES;
		SET @DRet=0;		SET @COMMENT='';
		if @isControlDriverCardNum=1  AND (@v_ser!='' OR @v_num!='')
		IF EXISTS(SELECT UniKey FROM DRIVERS WITH (nolock) WHERE v_ser=@v_ser AND v_num=@v_num AND UniKey<>@UniKey)
			begin
			SET @DRet=1;
			SELECT TOP 1 @COMMENT=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_DRIVER_SERIAL_EXISTS' AND LngKey IN (SELECT TOP 1 LngMain FROM PROPERTIES);
			--SET @COMMENT='         .';
			end;
		if @isControlDriverPassport=1 AND (@p_ser!='' OR @p_num!='')
		IF EXISTS(SELECT UniKey FROM DRIVERS WITH (nolock) WHERE p_ser=@p_ser AND p_num=@p_num AND UniKey<>@UniKey)
			begin
			SET @DRet=1;
			if @COMMENT!='' SET @COMMENT=@COMMENT+char(10);
			SELECT TOP 1 @MessageText=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_DRIVER_PASSPORT_EXISTS' AND LngKey IN (SELECT TOP 1 LngMain FROM PROPERTIES);
			SET @COMMENT=@COMMENT+@MessageText; --'        .';
			end;
		if @isControlDriverFIO=1	
		IF EXISTS(SELECT UniKey FROM DRIVERS WITH (nolock) WHERE FA=@FA AND IM=@IM AND OT=@OT AND UniKey<>@UniKey)
			begin
			SET @DRet=1;
			if @COMMENT!='' SET @COMMENT=@COMMENT+char(10);
			SELECT TOP 1 @MessageText=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_DRIVER_FIO_EXISTS' AND LngKey IN (SELECT TOP 1 LngMain FROM PROPERTIES);
			SET @COMMENT=@COMMENT+@MessageText;	--'     .';
			end;
		IF @JLogin IS NOT NULL
			begin
			IF EXISTS(SELECT UniKey FROM DRIVERS WITH (nolock) WHERE JLogin LIKE @JLogin AND UniKey<>@UniKey)
				begin
				SELECT TOP 1 @Q=[dbo].[getFIO](UniKey) FROM DRIVERS WITH (nolock) WHERE JLogin=@JLogin AND UniKey<>@UniKey;
				SET @DRet=1;
				if LEN(@COMMENT)>0 SET @COMMENT=@COMMENT+char(10);
				SELECT TOP 1 @MessageText=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_DRIVER_LOGIN_EXISTS' AND LngKey IN (SELECT TOP 1 LngMain FROM PROPERTIES);
				SET @COMMENT=@COMMENT+@MessageText+' '+@Q;	--'         : '+@Q;
				end;		
			end;
		SET @UniKey=@DRet;
		return;
		end;
	if @R=9 /*   */
		begin
		if (@UserUpdate IS NOT NULL)
			begin
			SELECT @UserGroupKey=UserGroupKey, @isShowAllZakazType=isShowAllZakazType, @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WITH (nolock) WHERE UniKey=@UserUpdate;
			end;
		SELECT UNIKEY,dbo.GetFIO(UNIKEY) FIO,dbo.GetCurrentTaxiNum(UNIKEY,GETDATE()) TaxiNum, (SELECT GOV_NUMBER FROM Cars WITH (nolock) WHERE UniKey=[dbo].[GetCarByDriver](DDD.UNIKEY,GETDATE()))as GOV_NUMBER  FROM DRIVERS DDD WITH (nolock) WHERE DDD.v_state=0 ORDER BY TaxiNum;
		return;
		end;
	if @R=10 /*     */
		begin
			UPDATE TAXI_DR SET DATEOUT=DATEADD(ss,-1,GETDATE()) WHERE DRIVER=@UniKey AND DATEOUT is null;
		return;
		end;
	if @R=11 /*  .  - */
		begin
		if (@UserUpdate IS NOT NULL)
			begin
			SELECT @UserGroupKey=UserGroupKey, @isShowAllZakazType=isShowAllZakazType, @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WHERE UniKey=@UserUpdate;
			end;
		SET @Q='SELECT DDD.UNIKEY,dbo.GetFIO(DDD.UNIKEY) FIO,CCC.GOV_NUMBER,TDR.TAXI as TaxiNum 
		FROM DRIVERS DDD WITH (nolock)
		LEFT JOIN TAXI_DR TDR ON TDR.DRIVER=DDD.UniKey AND (DATEIN<=GETDATE() AND (DATEOUT IS NULL OR DATEOUT>=GETDATE()))
		LEFT JOIN Cars CCC ON CCC.UniKey=TDR.Car';
		--  ,    
		if(@UserGroupKey IS NOT NULL) SET @Q=@Q+' INNER JOIN UsersGroupsDrivers UGD ON UGD.UserGroupKey='+CAST(@UserGroupKey as varchar(16))+' AND UGD.DriverKey=DDD.UniKey';
		SET @Q =@Q + ' WHERE ';
		if (@UniKey IS NULL)  SET @Q =@Q + ' v_state=0 ';
			ELSE SET @Q =@Q + ' (v_state=0 OR DDD.UniKey='+CAST(@UniKey as varchar(12))+')';
		if (@UserUpdate IS NOT NULL)
			begin
			SELECT @isShowAllZakazType=isShowAllZakazType, @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WHERE UniKey=@UserUpdate;
			--    
			if @isShowAllGeoRegion=0 SET @Q =@Q + ' AND DDD.isJLockGeoRegion=1 AND DDD.JLockGeoRegion IN (SELECT GeoRegion FROM User_GeoRegion_Link WITH (nolock) WHERE UserKey='+CAST(@UserUpdate as varchar(12))+')';
			--     
			if @isShowAllZakazType=0 SET @Q =@Q + ' AND CarType IN (SELECT ZakazType FROM User_ZakazType_Link WITH (nolock) WHERE UserKey='+CAST(@UserUpdate as varchar(12))+')';
			end;
		SET @Q =@Q + ' ORDER BY FIO';
		Exec (@Q);
		return;
		end;
	if @R=12 /*         */
		begin
		if @v_date IS NULL
			SET @UniKey=dbo.GetDriverByTaxiNum(@TaxiNum,GETDATE());
			else
			SET @UniKey=dbo.GetDriverByTaxiNum(@TaxiNum,@v_date);
		return;
		end;
	if @R=13 /*      +       */
		begin
		EXEC [dbo].[P_Drivers_Actions] @R=51, @Driver=@UniKey;
		Select ActiveBalance as DriverSUMDolg,
			dbo.ZalogSUM(@UniKey) as DriverSumZalog  FROM DriversPlace ddd WITH (nolock) Where Driver=@UniKey;
		return;
		end;
end;
