ALTER PROCEDURE [dbo].[p_Drivers_Place_Operator] (@R int=1,
@CurrentUserUniKey int=null,
@AddSQL varchar(2000)=null,
@SelectOrder varchar(2000)=null
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <21/01/2014>
-- Update date: <09/07/2015>
-- Description:	< -       >
-- =============================================
SET DATEFORMAT dmy;
DECLARE @isShowAllGeoRegion bit=1,@JparkType int,@JDistribution int=1,@Q varchar(4000),@UserGroupKey int=null;
	-- 
	SELECT TOP 1 @JDistribution=JDistribution, @JparkType=JparkType FROM PROPERTIES;
		if (@CurrentUserUniKey IS NOT NULL)
			begin
			SELECT @UserGroupKey=UserGroupKey FROM USERS WHERE UniKey=@CurrentUserUniKey;
			end;
	
	
	SET @Q='SELECT DP.ClientType, DP.DateUpdate,DP.Driver,DP.GeoRegion,DP.isFree,DP.isManual,DP.isOnline,
			DP.UniKey,DP.UserUpdate,DP.ZakazCount,DP.Zone,DP.ZoneUpdate,
			DP.lat,DP.lon, DP.lat_prev,DP.lon_prev,DP.ZAKAZPLACE,DP.[QUEUE],DP.current_speed,
			GR.NameGeoRegion,ZZZ.NAMEZONE as RealNAMEZONE,DCT.ClientTypeName,';
	if @R=1 /*    */
		begin
			SET @Q=@Q+'dbo.GetFIO(DP.Driver) as FIO,
			[dbo].[getDriverState](DP.Driver,DP.ActiveBalance) as DriverState,
			tdr.TAXI as TaxiNum, CCC.GOV_NUMBER,CCC.CarType,ZT.TC_image_index,';
			if (@JDistribution=3 OR @JDistribution=4)	SET @Q=@Q+'[dbo].[GetDriverRatingFinal](DP.driver) as RatingFinal,';
			else SET @Q=@Q+'0 as RatingFinal, 0 as RatingFinalInvisible,';
		end;
	if @R=2 /*    */
		begin
			SET @Q=@Q+'DP.TMP_FIO as FIO,
			DP.TMP_DriverState as DriverState,
			DP.TMP_CallSign as TaxiNum, DP.TMP_GOV_NUMBER as GOV_NUMBER,DP.TMP_CarType as CarType,DP.TMP_TC_image_index as TC_image_index,';
			if (@JDistribution=3 OR @JDistribution=4)	SET @Q=@Q+'DP.TMP_RatingFinal as RatingFinal, DP.TMP_RatingFinalInvisible as RatingFinalInvisible,';
				else SET @Q=@Q+'0 as RatingFinal, 0 as RatingFinalInvisible,';
		end;
 
		SET @Q=@Q+'''NAMEZONE''=case WHEN DP.ZONE IS NULL THEN GR.NameGeoRegion ELSE ZZZ.NAMEZONE END
			FROM DriversPlace DP WITH (nolock)
			LEFT JOIN Zone ZZZ ON ZZZ.UNIKEY=DP.Zone
			LEFT JOIN GeoRegions GR ON DP.GeoRegion=GR.UniKey
			LEFT JOIN DriverClientType DCT ON DCT.UniKey=DP.ClientType AND DCT.Lng =(SELECT TOP 1 LngMain FROM PROPERTIES)';
	--  ,    
	if(@UserGroupKey IS NOT NULL) SET @Q=@Q+' INNER JOIN UsersGroupsDrivers UGD ON UGD.UserGroupKey='+CAST(@UserGroupKey as varchar(16))+' AND UGD.DriverKey=DP.Driver';
			
	if @R=1 /*    */
		begin
			SET @Q=@Q+' LEFT JOIN TAXI_DR TDR ON TDR.DRIVER=DP.Driver AND (DATEIN<=GETDATE() AND (DATEOUT IS NULL OR DATEOUT>=GETDATE()))
			LEFT JOIN Cars CCC ON CCC.UniKey=TDR.Car
			LEFT JOIN ZAKAZ_TYPE ZT ON ZT.UniKey=CCC.CarType';
			end;
			SET @Q=@Q+' WHERE 1=1 ';
		if (@CurrentUserUniKey IS NOT NULL)
			begin
			SELECT @isShowAllGeoRegion=isShowAllGeoRegion FROM USERS WHERE UniKey=@CurrentUserUniKey;
			--    
			if @isShowAllGeoRegion=0 SET @Q =@Q + ' AND DP.GeoRegion IN (SELECT GeoRegion FROM User_GeoRegion_Link WHERE UserKey='+CAST(@CurrentUserUniKey as varchar(12))+')';
			end;			
		if (@AddSQL IS NOT NULL) SET @Q=@Q+@AddSQL;
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder;
		if (@SelectOrder IS NULL) OR (CHARINDEX(@SelectOrder,'ORDER BY')=0)
			begin
			if (@JparkType=0) SET @Q=@Q+' ORDER BY ZZZ.NAMEZONE'
				else SET @Q=@Q+' ORDER BY GR.NameGeoRegion';
			if (@JDistribution=0)	SET @Q=@Q+',Queue ASC';
			if (@JDistribution=1)	SET @Q=@Q+',ZakazCount DESC';
			if (@JDistribution=3)	SET @Q=@Q+',RatingFinal DESC, ZoneUpdate ASC';
			if (@JDistribution=4)	SET @Q=@Q+',RatingFinal DESC,Queue ASC, ZoneUpdate ASC';
		end;
		exec (@Q);
END
