ALTER PROCEDURE [dbo].[P_BalanceSheet](@R int=1,@UniKey int=NULL, @DateBegin datetime=null,
@DateEnd datetime=null,@SelectOrder varchar(128)=null,@ret integer=NULL OUTPUT)  AS
begin
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <17/02/2010>
-- Update date: <02/07/2015>
-- Description:	</*       */>
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON
DECLARE @Driver int, @DDateBegin datetime, @MonthCount integer,@Count Integer,@DDateA datetime,
@DDateE datetime,@DDateB datetime,@DDolg money,@DDolgA money,@DCashIN money;

	if @R=1 /**/
		begin
		SELECT CAST(SUM(SumBegin) AS Decimal(10,2)) SumBeginA,CAST(SUM(SumEnd) AS Decimal(10,2)) SumEndA,MIN(DateBegin) DateBeginA,MIN(DateEnd) DateEndA FROM BalanceSheet GROUP By DateBegin ORDER BY DateBegin;
		return;
		end;
	if @R=2 /*     */
		begin
		--         
		SELECT @DDateBegin=MIN(DATEIN) FROM BASE bbb LEFT JOIN ZakazExitType ZET ON ZET.UniKey=bbb.OtkazClienta WHERE bbb.Driver=@UniKey AND ZET.IsError=0;
		SELECT @DDateA=MIN(CI.DATEOF) FROM CashIn CI WHERE CI.Driver=@UniKey;
		if (@DDateA IS NOT NULL) AND (@DDateA<@DDateBegin) SET @DDateBegin=@DDateA;
		if (@DDateBegin IS NULL)
			begin
			SET @ret=NULL;
			end
			else
			begin
			--      
			SET @MonthCount=DATEDIFF(m,@DDateBegin,GETDATE());
			SET @DDateB='01.01.2000';
			SET @DDateB=DATEADD(m,DATEDIFF(m,@DDateB,@DDateBegin),@DDateB);
			--     
			DELETE FROM BalanceSheet WHERE DRIVER=@UniKey;
			--      
			SET @Count=0;
			SET @DDolgA=0;
			WHILE (@Count<@MonthCount)
				begin
				SET @DDateA=DATEADD(m,@Count,@DDateB); -- 
				SET @DDateE=DATEADD(m,1,@DDateA);	-- 
				SET @DDateE=DATEADD(s,-1,@DDateE);	-- 		
				--      
				UPDATE BASE SET Debt=isnull([dbo].[GetSUMDolgByZakaz](UniKey),0)
					WHERE DRIVER=@UniKey AND DateIn>=@DDateA 
						AND DATEIN<=@DDateE AND ZAKAZPLACE=100;
				--         
				SET @DDolg=dbo.GetDriverSUMDolgPeriod(@UniKey,@DDateA,@DDateE,1)+@DDolgA;
				SET @DCashIN=dbo.CashInSUMByPeriod(@UniKey,@DDateA,@DDateE);
				--SET @DDolgRef=[dbo].[GetDriverSUMPiramidePeriodRef](@UniKey,@DDateA,@DDateE);
				INSERT INTO BalanceSheet (DRIVER,DateBegin,DateEnd,SumBegin,SumEnd) VALUES(@UniKey,@DDateA,@DDateE,@DDolgA,@DDolg-@DCashIN);
				SET @DDolgA=@DDolg-@DCashIN;
				SET @Count=@Count+1;
				end;
			SET @ret=1;
			end;
		return;
		end;
	if @R=3 /*           */
		begin
		--       
		SET @DDateBegin=@DateBegin;
		if (@DDateBegin IS NULL)
			begin
			SET @ret=NULL;
			end
			else
			begin
			--      
			SET @MonthCount=DATEDIFF(m,@DDateBegin,GETDATE());
			SET @DDateB='01.01.2000';
			SET @DDateB=DATEADD(m,DATEDIFF(m,@DDateB,@DDateBegin),@DDateB);
			--     
			DELETE FROM BalanceSheet WHERE DRIVER=@UniKey AND DateBegin>=@DDateB;
			--      
			SELECT @DDolgA=SumEnd FROM BalanceSheet WHERE DateBegin=DATEADD(m,-1,@DDateB) AND DRIVER=@UniKey;
			if (@DDolgA IS NULL) SET @DDolgA=0;
			SET @Count=0;
			--      
			WHILE (@Count<@MonthCount)
				begin
				SET @DDateA=DATEADD(m,@Count,@DDateB); -- 
				SET @DDateE=DATEADD(m,1,@DDateA);	-- 
				SET @DDateE=DATEADD(s,-1,@DDateE);	-- 
				--      
				UPDATE BASE SET Debt=isnull([dbo].[GetSUMDolgByZakaz](UniKey),0)
					WHERE DRIVER=@UniKey AND DateIn>=@DDateA 
						AND DATEIN<=@DDateE AND ZAKAZPLACE=100;
				--         
				SET @DDolg=dbo.GetDriverSUMDolgPeriod(@UniKey,@DDateA,@DDateE,1)+@DDolgA;
				SET @DCashIN=dbo.CashInSUMByPeriod(@UniKey,@DDateA,@DDateE);
				INSERT INTO BalanceSheet (DRIVER,DateBegin,DateEnd,SumBegin,SumEnd) VALUES(@UniKey,@DDateA,@DDateE,@DDolgA,@DDolg-@DCashIN);
				SET @DDolgA=@DDolg-@DCashIN;
				SET @Count=@Count+1;
				end;
			SET @ret=1;
			end;
		return;
		end;
	if @R=4 /*     */
		begin
		--       
		SET @DDateB='01.01.2000';
		SET @DDateB=DATEADD(m,DATEDIFF(m,@DDateB,DATEADD(m,-1,GETDATE())),@DDateB);
		SET @DDateBegin=@DDateB;
		if (@DDateBegin IS NULL)
			begin
			SET @ret=NULL;
			end
			else
			begin
			--      
			SET @MonthCount=DATEDIFF(m,@DDateBegin,GETDATE());
			SET @DDateB='01.01.2000';
			SET @DDateB=DATEADD(m,DATEDIFF(m,@DDateB,@DDateBegin),@DDateB);
			--     
			DELETE FROM BalanceSheet WHERE DRIVER=@UniKey AND DateBegin>=@DDateBegin;
			--      
			SELECT @DDolgA=SumEnd FROM BalanceSheet WHERE DateBegin=DATEADD(m,-1,@DDateB) AND DRIVER=@UniKey;
			if (@DDolgA IS NULL) SET @DDolgA=0;
			SET @Count=0;
			--      
			WHILE (@Count<@MonthCount)
				begin
				SET @DDateA=DATEADD(m,@Count,@DDateB); -- 
				SET @DDateE=DATEADD(m,1,@DDateA);	-- 
				SET @DDateE=DATEADD(s,-1,@DDateE);	-- 
				--         
				SET @DDolg=dbo.GetDriverSUMDolgPeriod(@UniKey,@DDateA,@DDateE,0)+@DDolgA;
				
				SET @DCashIN=dbo.CashInSUMByPeriod(@UniKey,@DDateA,@DDateE);
				INSERT INTO BalanceSheet (DRIVER,DateBegin,DateEnd,SumBegin,SumEnd) VALUES(@UniKey,@DDateA,@DDateE,@DDolgA,@DDolg-@DCashIN);
				SET @DDolgA=@DDolg-@DCashIN;
				SET @Count=@Count+1;
				end;
			SET @ret=1;
			end;
		return;
		end;
	if @R=5 /*   */
		begin
		SELECT UniKey, CAST(SumBegin AS Decimal(10,2)) SumBegin,CAST((SumEnd) AS Decimal(10,2)) SumEnd,(DateBegin) DateBegin,(DateEnd) DateEnd FROM BalanceSheet WHERE DRIVER=@UniKey ORDER BY DateBegin;
		return;
		end;
	if @R=6 /*    */
		begin
		SET @DDateB='01.01.2000';
		SET @DDateB=DATEADD(m,DATEDIFF(m,@DDateB,GETDATE()),@DDateB);

		SELECT @Count=COUNT(UNIKEY)  FROM BalanceSheet WHERE DateBegin=DATEADD(m,-1,@DDateB);

		SELECT @MonthCount=COUNT(UNIKEY)  FROM DRIVERS ddd WHERE ddd.UNIKEY IN (SELECT DRIVER FROM TAXI_DR 
			WHERE DRIVER=ddd.UNIKEY AND (DateIN<=@DDateB) AND (DateOut>=DATEADD(m,-1,@DDateB) OR DATEOUT is NULL));
		if @Count>=@MonthCount SET @ret=0;
			else SET @ret=-1; --
		return;
		end;
	if @R=7 /*    -    */
		begin
		--     00  ,  
		SET @DDateB='01.01.2000';
		SET @DDateB=DATEADD(m,DATEDIFF(m,@DDateB,DATEADD(m,-1,GETDATE())),@DDateB);
		SET @DDateBegin=@DDateB;
		SET @DDateE=DATEADD(m,1,@DDateB);	-- 
		SET @DDateE=DATEADD(s,-1,@DDateE);	-- 
		print @DDateBegin;
		DECLARE ProfileDriversCursor CURSOR FOR
			SELECT UniKey FROM Drivers WITH(nolock) WHERE v_state=0;
		OPEN ProfileDriversCursor
		FETCH NEXT FROM ProfileDriversCursor INTO @Driver
		WHILE @@FETCH_STATUS = 0
			BEGIN
			--      
			SELECT @DDolgA=SumEnd FROM BalanceSheet WITH(nolock) WHERE DateBegin=DATEADD(m,-1,@DDateBegin) AND DRIVER=@Driver;
			SET @DDolgA=isnull(@DDolgA,0);
			--     
			if NOT EXISTS (SELECT * FROM BalanceSheet WHERE DRIVER=@Driver AND DateBegin>=@DDateBegin)
				begin
				SET @DDolg=NULL;
				SELECT TOP 1 @DDolg=ActiveBalance FROM DriversPlace WITH(nolock) WHERE Driver=@Driver;
				if(@DDolg IS NOT NULL)
					begin
					INSERT INTO BalanceSheet (DRIVER,DateBegin,DateEnd,SumBegin,SumEnd) VALUES
						(@Driver,@DDateBegin,@DDateE,@DDolgA,@DDolg);
					print CAST(@DDolg as varchar(16))+' KEY='+ CAST( @Driver as varchar(116))+' BEGIN='+CAST(@DDateBegin as varchar(116))+' END='+CAST(@DDateE as varchar(116));
					end;
				end;	
			FETCH NEXT FROM ProfileDriversCursor INTO @Driver
			END;
		CLOSE ProfileDriversCursor;
		DEALLOCATE ProfileDriversCursor;		
		return;
		end;
END;
