ALTER FUNCTION [dbo].[GetZakazDiscount](@Zakaz int,@Price money)
RETURNS money
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <13.04.2012>
-- Update date: <09.07.2015>
-- Description:	<        >
-- =============================================
	DECLARE @RES money=0, @isFree bit, @Limit money, @DiscountValue float,@DiscountType int,
		@DiscountValueType int, @hourpay smallint,@isKmEnabled bit,
		@PriceRoundType int, @Rate int, @PriceRoundMethod int=0, @PriceRoundValue int=0,
		@OtherServicePercentPrice float=0,
		@OtherServiceFixedPrice money=0,
		@PriceLanding money=0, @isTaximeter bit,@GPXPrice money,
	@vMaxLimit money=0,
	@vFixedDiscountTypePrice money=0,
	@vFixedDiscountTypeOtherService money=0,
	@vFixedDiscountTypeHourPrice money=0,
	@vFixedDiscountTypeTaximeterLanding money=0,
	@vFixedDiscountTypeTaximeterKmCity money=0,
	@vFixedDiscountTypeTaximeterKmInterCity money=0,
	
	@vPercentDiscountTypePrice float=0,
	@vPercentDiscountTypeOtherService float=0,
	@vPercentDiscountTypeHourPrice float=0,
	@vPercentDiscountTypeTaximeterLanding float=0,
	@vPercentDiscountTypeTaximeterKmCity float=0,
	@vPercentDiscountTypeTaximeterKmInterCity float=0;
		
	SELECT @Rate=Rate,@hourpay=hourpay,@isKmEnabled=isKmEnabled FROM BASE WHERE UniKey=@Zakaz;
	SELECT @PriceRoundType=PriceRoundType,@PriceRoundMethod=PriceRoundMethod,@PriceRoundValue=PriceRoundValue,
		@PriceLanding=PriceLanding,@isTaximeter=isTaximeter
	 FROM Rates WHERE UniKey=@Rate;
	
	DECLARE DiscountCalcCursor CURSOR FOR
		SELECT DO.DiscountType,DO.DiscountValue,DO.DiscountValueType,DO.Limit,DO.isFree FROM DiscountOrders DO
			WHERE DO.OrderKey=@Zakaz;
	OPEN DiscountCalcCursor
	FETCH NEXT FROM DiscountCalcCursor INTO @DiscountType,@DiscountValue,@DiscountValueType,@Limit,@isFree
	WHILE @@FETCH_STATUS = 0
		BEGIN
		--
		if @DiscountType=1
			begin
			if @DiscountValueType=1 
			begin
			SET @vFixedDiscountTypePrice=@vFixedDiscountTypePrice+@DiscountValue;
			if @vMaxLimit<@Limit SET @vMaxLimit=@Limit;
			end;
			if @DiscountValueType=2 SET @vFixedDiscountTypeOtherService=@vFixedDiscountTypeOtherService+@DiscountValue;
			if @DiscountValueType=3 SET @vFixedDiscountTypeHourPrice=@vFixedDiscountTypeHourPrice+@DiscountValue;
			if @DiscountValueType=4 SET @vFixedDiscountTypeTaximeterLanding=@vFixedDiscountTypeTaximeterLanding+@DiscountValue;
			if @DiscountValueType=5 SET @vFixedDiscountTypeTaximeterKmCity=@vFixedDiscountTypeTaximeterKmCity+@DiscountValue;
			if @DiscountValueType=6 SET @vFixedDiscountTypeTaximeterKmInterCity=@vFixedDiscountTypeTaximeterKmInterCity+@DiscountValue;
			end;
		--%
		if @DiscountType=2
			begin
			if @DiscountValueType=1 
			begin
				SET @vPercentDiscountTypePrice=@vPercentDiscountTypePrice+@DiscountValue;
				if @vMaxLimit<@Limit SET @vMaxLimit=@Limit;
			end;
			if @DiscountValueType=2 SET @vPercentDiscountTypeOtherService=@vPercentDiscountTypeOtherService+@DiscountValue;
			if @DiscountValueType=3 SET @vPercentDiscountTypeHourPrice=@vPercentDiscountTypeHourPrice+@DiscountValue;
			if @DiscountValueType=4 SET @vPercentDiscountTypeTaximeterLanding=@vPercentDiscountTypeTaximeterLanding+@DiscountValue;
			if @DiscountValueType=5 SET @vPercentDiscountTypeTaximeterKmCity=@vPercentDiscountTypeTaximeterKmCity+@DiscountValue;
			if @DiscountValueType=6 SET @vPercentDiscountTypeTaximeterKmInterCity=@vPercentDiscountTypeTaximeterKmInterCity+@DiscountValue;
			end;
		FETCH NEXT FROM DiscountCalcCursor INTO @DiscountType,@DiscountValue,@DiscountValueType,@Limit,@isFree
		END;
	CLOSE DiscountCalcCursor;
	DEALLOCATE DiscountCalcCursor;	
--     
	if @Limit>0 AND @vFixedDiscountTypePrice>@Limit SET @vFixedDiscountTypePrice=@Limit;
	--	
	SET @RES=@Price-@vFixedDiscountTypePrice;
	if @Limit>0 AND (@vPercentDiscountTypePrice*@Price/100)>@Limit
		SET @RES=@RES-@Limit;
		else
		begin
		SET @RES=@RES-(@vPercentDiscountTypePrice*@Price/100);
		end;
	if  (@isFree=1 AND @Limit=0) SET @RES=0; -- ,  
	--    -    ,  
	if @hourpay=1 OR @isKmEnabled=1
		begin
		SET @RES=@RES-@vFixedDiscountTypeHourPrice;
		if(@vPercentDiscountTypeHourPrice!=0)
			begin
			--     
			SET @RES=@RES-(@vPercentDiscountTypeHourPrice*ISNULL([dbo].[GetPriceHour](@Zakaz),0)/100);
			end;
		end;
	--. 
	if @vFixedDiscountTypeOtherService>0
		begin
		SELECT @OtherServiceFixedPrice=SUM(BAS.Price) FROM BaseAdditionalServices BAS
			WHERE BAS.OrderKey=@Zakaz AND BAS.OtherServiceKey IS NOT NULL
		SET @OtherServiceFixedPrice=isnull(@OtherServiceFixedPrice,0)
		if(@OtherServiceFixedPrice>=@vFixedDiscountTypeOtherService)
			SET @RES=@RES-@vFixedDiscountTypeOtherService;
		end;
	if @vPercentDiscountTypeOtherService>0
		begin
		SELECT @OtherServicePercentPrice=SUM(BAS.OtherServicePercentPrice)
			FROM BaseAdditionalServices BAS
			WHERE BAS.OrderKey=@Zakaz AND BAS.OtherServiceKey IS NOT NULL
		if @OtherServicePercentPrice>0
			begin
			--     . 
			SET @RES=@RES-(ISNULL([dbo].[GetPriceBase](@Zakaz),0)*isnull(@OtherServicePercentPrice,0)/100)*@vPercentDiscountTypeOtherService/100;
			end;
		end;
	if @isTaximeter=1
		begin
		--
		if @PriceLanding>0 SET @RES=@RES-@vFixedDiscountTypeTaximeterLanding-@vPercentDiscountTypeTaximeterLanding*@PriceLanding/100;
		-- 
		SELECT @GPXPrice=SUM(Summa) FROM GPXCalc WHERE Zakaz=@Zakaz AND GPXCalcType=3;
		SET @GPXPrice=ISNULL(@GPXPrice,0);
		if @GPXPrice>=@vFixedDiscountTypeTaximeterKmCity SET @RES=@RES-@vFixedDiscountTypeTaximeterKmCity;
		SET @RES=@RES-@vPercentDiscountTypeTaximeterKmCity*@GPXPrice/100;

		-- 
		SELECT @GPXPrice=SUM(Summa) FROM GPXCalc WHERE Zakaz=@Zakaz AND GPXCalcType=9;
		SET @GPXPrice=ISNULL(@GPXPrice,0);
		if @GPXPrice>=@vFixedDiscountTypeTaximeterKmInterCity SET @RES=@RES-@vFixedDiscountTypeTaximeterKmInterCity;
		SET @RES=@RES-@vPercentDiscountTypeTaximeterKmInterCity*@GPXPrice/100;
		end;
/*	
	--  VIP 
	SELECT TOP 1 @isFree=DDD.isFree, @FreeLimit=DDD.FreeLimit, @Discount=DDD.Discount,
		@DiscountPercent=DDD.DiscountPercent
		FROM VipDiscount VD LEFT JOIN Discounts DDD ON DDD.UniKey=VD.Discount WHERE	VD.Zakaz=@Zakaz;

	if @isFree IS NULL
		begin
		--     
		SELECT TOP 1 @isFree=DDD.isFree, @FreeLimit=DDD.FreeLimit, @Discount=DDD.Discount ,
			@DiscountPercent=DDD.DiscountPercent
			FROM PhoneDiscount PD LEFT JOIN Discounts DDD ON DDD.UniKey=PD.Discount WHERE	PD.Zakaz=@Zakaz;
		end;

	if @isFree IS NOT NULL
		begin
		IF @isFree=1 
			begin
            --
            if @Price>@FreeLimit SET @Res=@Price-@FreeLimit;
                else SET @Res=0;
			end
			else
			begin
			--%
			if @DiscountPercent>0
				begin
				SET @Res=@Price*(100-@DiscountPercent)/100;
				end
				else
				begin
				if @Price>=@Discount SET @Res=@Price-@Discount;
					else SET @Res=0;		
				end;
			end;
		RETURN [dbo].[GetRoundSum](@PriceRoundType,@RES,@PriceRoundMethod,@PriceRoundValue);
		end
		else
		begin
		--   
		--DECLARE @isHasCash bit=0;
		SELECT @DiscountPercent=cc.Discount FROM CardOrderLink COL LEFT JOIN Cards cc ON cc.UniKey=COL.[Card]
			WHERE COL.[Order]=@Zakaz;
		--if (ISNULL(@isHasCash,0)=0) 
		SET @DiscountPercent=ISNULL(@DiscountPercent,0);
		if(@DiscountPercent>0) SET @Res=@Price*(100-@DiscountPercent)/100;
			ELSE
			SET @RES=@Price;
		end;
*/		
	IF @RES<0 SET @RES=0;
	RETURN [dbo].[GetRoundSum](@PriceRoundType,@RES,@PriceRoundMethod,@PriceRoundValue);
END
